#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int tabela[5000][5000];


void boje(int x, int y, int n, int m)
{
        tabela[x][y]=1;
        if(tabela[x][y+1]==0 && y<m)
            boje(x,(y+1),n,m);
        if(tabela[x+1][y]==0 && x<n)
            boje((x+1),y,n,m);
        if(tabela[x-1][y]==0 && x>1)
            boje((x-1),y,n,m);
        if(tabela[x][y-1]==0 && y>1)
            boje(x,(y-1),n,m);
}

int main()
{
    int i,x,y,n,m,k,j,br=0;
    scanf("%d%d%d",&n,&m,&k);
    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            tabela[i][j]=0;
    for(i=0;i<k;i++)
    {
        scanf("%d %d",&x,&y);
        tabela[x][y]=1;
    }
    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            if(tabela[i][j]==0)
            {
                br++;
                boje(i,j,n,m);
            }
        printf("%d",br);
        printf("\n");
}